import java.sql.*;
import java.util.*;
import java.util.regex.*;
import java.sql.*;
import bitel.billing.server.util.*;
import bitel.billing.server.contract.bean.*;
import bitel.billing.common.*;
import java.math.BigDecimal;
import java.text.DecimalFormat;

public void fillReport( con, filter, bitel.billing.server.reports.BGCSVReport.ReportResult result )
{
	int face = filter.getIntParam( "type", -1 );
	long group = filter.getLongParam( "contractGroups" );
	String status = filter.getStringParam( "status" );
	Calendar date = filter.getCalendarParam( "date" );
	Calendar month = filter.getCalendarParam( "month" );
	Calendar month_next = filter.getCalendarParam( "month" );
	String order = filter.getStringParam( "orderBy" );
	DecimalFormat dfSumm = new DecimalFormat( "0.00" );

	query = "SELECT gr.title FROM contract_group gr WHERE (1<<gr.id) & ?>0";
	PreparedStatement getGroups = con.prepareStatement( query );
	
	query = "SELECT c.id, c.gr, param_client.val, param_contract.val, param_account.val, param_phone.val, IFNULL(s.saldo,0)+IFNULL(p.summa,0) AS dept" +
			" FROM contract c" +
			//" LEFT JOIN contract_status cs ON c.id=cs.cid AND cs.date1<=CURDATE() AND (cs.date2 IS NULL OR cs.date2>=CURDATE())" +
			" LEFT JOIN contract_parameter_type_1 param_client ON param_client.cid=c.id AND param_client.pid=1" +
			" LEFT JOIN contract_parameter_type_1 param_contract ON param_contract.cid=c.id AND param_contract.pid=28" +
			" LEFT JOIN contract_parameter_type_1 param_account ON param_account.cid=c.id AND param_account.pid=3" +
			" LEFT JOIN contract_parameter_type_1 param_phone ON param_phone.cid=c.id AND param_phone.pid=26" +

			" LEFT JOIN (SELECT SUBSTR(MAX(CONCAT(RPAD(cb.yy*100+cb.mm,6,' '), cb.summa1+cb.summa2-cb.summa3-cb.summa4 )),7) AS saldo, cb.cid AS cid" +
			  			" FROM contract_balance cb WHERE cb.yy<? OR (cb.yy=? AND cb.mm<=?) GROUP BY cid) s ON c.id=s.cid" +
			" LEFT JOIN (SELECT SUM(cp.summa) AS summa, cp.cid AS cid FROM contract_payment cp" +
						" WHERE cp.dt >=? AND cp.dt <=? GROUP BY cp.cid) p ON c.id=p.cid" +
			
			" WHERE ( IFNULL(s.saldo,0)+IFNULL(p.summa,0)<0 ) AND (c.scid=-1 OR c.scid=0 OR (c.sub_mode=1))";
	
	//System.out.println( query );
	if( !status.equals( "" ) )
	{
		query += " AND c.status IN (" + status + ")";
	}
	if( face >= 0 )
	{
		query += " AND c.fc = " + face;
	}
	if( group > 0 )
	{
		query += " AND (c.gr & ?) > 0 ";
	}
	
	if( order.equals( "one" ) )
	{
		query += " ORDER BY param_client.val ";
	}
	if( order.equals( "two" ) )
	{
		query += " ORDER BY dept ";
	}	
	if( order.equals( "three" ) )
	{
		query += " ORDER BY param_client.val DESC ";
	}	
	if( order.equals( "four" ) )
	{
		query += " ORDER BY dept DESC";
	}	
	//System.out.println( query );

	ps = con.prepareStatement( query );

	int index = 1;
	
	month_next.add( Calendar.MONTH, 1 );
	
	ps.setInt( index++, month.get( Calendar.YEAR ) );
	ps.setInt( index++, month.get( Calendar.YEAR ) );
	//System.out.println( month.get( Calendar.YEAR ) );
	ps.setInt( index++, month.get( Calendar.MONTH ) + 1 );
	//System.out.println( month_next.get( Calendar.MONTH ) );

	ps.setDate( index++, TimeUtils.convertCalendarToSqlDate( month_next ) );
	//System.out.println( TimeUtils.convertCalendarToSqlDate( month ) );

	ps.setDate( index++, TimeUtils.convertCalendarToSqlDate(date) );
	//System.out.println( TimeUtils.convertCalendarToSqlDate(date) );	

	
	if( group > 0 )
	{
		ps.setLong( index++, group );
	}
	BigDecimal summa = BigDecimal.ZERO;
	data = new ArrayList( 1000 );
	rs = ps.executeQuery();
	
	while( rs.next() )
	{
		cid = rs.getInt( "c.id" );
		long gr = rs.getLong( "c.gr" );
		
		groups = "";
		
		getGroups.setLong( 1, gr );
		groupRS = getGroups.executeQuery();
		while( groupRS .next() )
		{		
			if( groups != "")
			{
				groups = groupRS.getString(1) + ", " + groups; 
			}
			else
			{
				groups = groupRS.getString(1);
			}
		}
		
		client = rs.getString( "param_client.val" );
		contract = rs.getString( "param_contract.val" );
		account = rs.getString( "param_account.val" );
		phone = rs.getString( "param_phone.val" );
		dept = rs.getBigDecimal( "dept" );
		summa = summa.add( dept );
		map = new HashMap();
		map.put( "cid", String.valueOf( cid ) );
		map.put( "client", client );
		map.put( "contract", contract );
		map.put( "account", account );
		map.put( "phone", phone );
		map.put( "dept_sum", dfSumm.format( dept ) );
		map.put( "group", groups );
		data.add( map );
	}
	
	map = new HashMap();
	map.put( "client", ":" );
	map.put( "dept_sum", dfSumm.format( summa ) );
	map.put( "group", "" );
	data.add( map );
	
	result.setData( data );
}
